#!/bin/bash


# error exit
error_exit() {
    /usr/local/bin/ledcont accblink
    /usr/local/bin/ledcont pwrblink
    /usr/local/sbin/leddrv_unload
    exit 1
}

# wait_atalk_daemon
# ATALKSERVICE=
wait_atalk_daemon(){
  [ -f /home/LANDISK/landisk-config ] && 
  ATALKSERVICE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "ATALKSERVICE" | awk -F "=" '{print $2}')
  if [ "${ATALKSERVICE}" = "on" ]; then
    i=0
    while [ $i -lt 180 ]; do
      ps | grep "S92netatalk" >& /dev/null
      if [ $? -ne 0 ]; then
        ps | grep "atalkd" >& /dev/null
        if [ $? -ne 0 ]; then
          break;
        fi
      fi
      sleep 1
      i=$((i+1))
    done
  fi
  ps | grep "atalkd" >& /dev/null
  if [ $? -eq 0 ]; then
    kill -9 `ps | grep "atalkd" | awk '{print $1}'`
  fi
  sleep 3
}


UPDATEVERSION="1.02"

# LED control.
/usr/local/bin/ledcont cycle 8
/usr/local/bin/ledcont pwrblink


#
# check system type and version.
#

# system type
[ -f /home/LANDISK/landisk-config ] && SYSTEMTYPE=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "SYSTEMTYPE" | awk -F "=" '{print $2}')

[ "${SYSTEMTYPE}" != "hdl-w" ] && error_exit

# system version
[ -f /home/LANDISK/landisk-config ] && SYSTEMVERSION=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "SYSTEMVERSION" | awk -F "=" '{print $2}')

# delete . from version
SYSVERINT=$(echo "${SYSTEMVERSION}" | cut -d "." -f 1)
SYSVERFLOAT=$(echo "${SYSTEMVERSION}" | cut -d "." -f 2)
SYSVER="${SYSVERINT}${SYSVERFLOAT}"

# delete . from version
UPVERINT=$(echo "${UPDATEVERSION}" | cut -d "." -f 1)
UPVERFLOAT=$(echo "${UPDATEVERSION}" | cut -d "." -f 2)
UPVER="${UPVERINT}${UPVERFLOAT}"

[ ${SYSVER} -gt ${UPVER} ] && error_exit
if [ ${SYSVER} = "101" ]; then
	VER101UP="true"
fi
if [ ${SYSVER} = "102" ]; then
	VER101UP="true"
	VER102UP="true"
fi
# system version
[ -f /home/LANDISK/landisk-config ] && AVELLINK=$(grep -v '^[#\;]' /home/LANDISK/landisk-config | grep -w "AVELLINK" | awk -F "=" '{print $2}')

/usr/bin/killall atkickd >& /dev/null
/home/LANDISK/scripts/killftpd.sh stop
/etc/rc.d/init.d/S99reset_daemon stop
/etc/rc.d/init.d/S92netatalk stop
/etc/rc.d/init.d/S91samba stop
# /etc/rc.d/init.d/S95httpd stop
/etc/rc.d/init.d/S90identd stop
/etc/rc.d/init.d/S60lpd stop
/etc/rc.d/init.d/S40cron stop
/etc/rc.d/init.d/S35dhcpcd stop
/etc/rc.d/init.d/S20network stop
/etc/rc.d/init.d/S15inet stop

# wait AppleShare Daemon
wait_atalk_daemon

mount -o remount,rw %root% /
[ $? != 0 ] && error_exit

# copy & mode change.
if [ "${VER101UP}" != "true" -o "{VER110UP}" != "true" ]; then
# Ver1.00
    tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C /
    [ $? != 0 ] && error_exit
fi

# chown,chmod lilo.conf
chown root:root /etc/lilo.conf
chmod 644 /etc/lilo.conf

# lilo
/sbin/lilo -v -r /
[ $? != 0 ] && error_exit

# Ver1.20 Change httpd.conf if AVeL on.
if [ "${AVELLINK}" = "on" ]; then
    rm -f /usr/local/apache/conf/httpd.conf
    ln -s /usr/local/apache/conf/httpd_AVeLLink.conf /usr/local/apache/conf/httpd.conf
fi

# Version UP.
/home/LANDISK/scripts/setparam.sh "SYSTEMVERSION" "${UPDATEVERSION}" /home/LANDISK/landisk-config
[ $? != 0 ] && error_exit

sync
mount -o remount,ro %root% /

rm -rf /mnt/hda3/.landisk-update/update.tgz
rm -rf /mnt/hda3/.landisk-update/update-files.tar.gz

# Wait
sync
mount -o remount,ro /dev/hda3 /mnt/hda3
# sleep 10

/home/LANDISK/scripts/powerctrl.sh reboot
exit 0

